﻿import As.util.*
import As.mvc.*
// Las tres clases siguientes se han modificado al igual que ésta para que no interfirieran en las galerías.
import As.XmlIcons.APhotoModelXml
import As.XmlIcons.APhotoViewIcons
import As.XmlIcons.APhotoControllerIcons

//Position interface elements
this.attachMovie("flecha", "back", -100, {_x:25, _y:12, _xscale:40, _yscale:40})
this.attachMovie("flecha", "forward", -99, {_x:473, _y:12, _xscale:40, _yscale:40, _rotation:180})
this.attachMovie("iconos", "icons", -498, {_x:51, _y:2, _xscale:80, _yscale:80})
this.attachMovie("paginas", "pag", -96, {_x:6, _y:328})
//Combobox with AS1 arquitecture, less heavy :)
// Aquí definiremos las categorías que aparecerán en el combo selector de galería.
this.attachMovie("FComboBoxSymbol", "cats", -95, {_x:315, _y:5})
cats.addItem("Alimentos y Bebidas", 1)
cats.addItem("Animales y Mascotas", 2)
cats.addItem("Arquitectura y Construcción", 3)
cats.addItem("Arte y Fotografía", 4)
cats.addItem("Automóviles", 5)
cats.addItem("Bodas", 6)
cats.addItem("Cafés y Restaurant", 7)
cats.addItem("Deportes", 8)
cats.addItem("Educación", 9)
cats.addItem("Empresa", 10)
cats.addItem("Entretenimiento", 11)
cats.addItem("Especiales", 12)
cats.addItem("Florerías", 13)
cats.addItem("Hoteles", 14)
cats.addItem("Infantiles", 15)
cats.addItem("Inmobiliarias", 16)
cats.addItem("Joyerías", 17)
cats.addItem("Medicina", 18)
cats.addItem("Muebles y Decoración", 19)
cats.addItem("Música", 20)
cats.addItem("Personales", 21)
cats.addItem("Profesionales", 22)
cats.addItem("Salud y Belleza", 23)
cats.addItem("Tecnología", 24)
cats.addItem("Tiendas en línea", 25)
cats.addItem("Turismo", 26)
cats.setSize(150);
cats.setChangeHandler("filter")
function filter(comp){ 	controller.setFilter(comp) }
//end of UI elements
// Tenemos que tener cuidado de modificar correctamente las funciones y clases.
model = new APhotoModelXml()
controller = new APhotoControllerIcons(model, this)
view = new APhotoViewIcons(model, controller, this)
controller.setView(view)
pag.setController(controller)
model.addObserver(view)
model.addObserver(pag)
model.addObserver(controller)
//Buttons handlers
back.onPress = function(){
controller.backward()
}
forward.onPress = function(){
controller.forward()
}
icons.onPress = function(){
this._visible = false
controller.icons("current")
this.enabled = false
this.gotoAndStop (1)
}
icons.onRollOver = function(){
this.gotoAndPlay(2)
}
icons.onRollOut = function(){
this.gotoAndStop(1)
}
icons._visible = false
back._visible = false
//Load inital data
// Aquí le indicaremos dónde encontrar el xml usado para definir las galerías.
model.loadData("multimedia/imagen/plantillas.xml")
a = setInterval(function(){
	var b = view.setupIcons(3, 5);	
	if(b){
		model.filter(1)		
		view.setState("icons")
		controller.icons("current")		
		clearInterval(a);
	}
}, 1000)
stop();