<?php
class WhoIs{
   function WhoIs(){
        $this->methodTable = array(
            "getTLDs" => array(
                "description" => "Regresa la lista de TLDs disponibles",
                "access" => "remote", // Posibles valores private, public, remote
                "arguments" => "Ninguno"
            ),
            "find" => array(
                "description" => "Bsca el registro de un dominio",
                "access" => "remote", // Posibles valores private, public, remote
                "arguments" => "Nombre de dominio, TLD"
            )
        );
   }
   function getTLDs(){
      include_once("tlds.php");
      return getArrayOfTlds();
   }
   function find($domainName, $NIC){
      $serverWhoIs = fsockopen($NIC,43); 
      fputs($serverWhoIs, $domainName . "\r\n");
      $answer = '';
      while(!feof($serverWhoIs)) 
         $answer .= fgets($serverWhoIs,128); 
      fclose($serverWhoIs);
      $answer = str_replace("\r\n", "\n", $answer);
      return $answer;
   }
}
?>